# table for L filter

# get the data

from pylab import *

m_type = 'L'

dp1=np.load(m_type + '/' + m_type + '1mdata.npy')
dp2=np.load(m_type + '/' + m_type + '2mdata.npy')
dp3=np.load(m_type + '/' + m_type + '3mdata.npy')
dp4=np.load(m_type + '/' + m_type + '4mdata.npy')
dp5=np.load(m_type + '/' + m_type + '5mdata.npy')

tmp = empty([29, 5])
tmp[:, 0] = dp1
tmp[:, 1] = dp2
tmp[:, 2] = dp3
tmp[:, 3] = dp4
tmp[:, 4] = dp5

thdi1 = tmp[0, :]
thdi2 = tmp[1, :]
thdi3 = tmp[2, :]
thdv1 = tmp[3, :]
thdv2 = tmp[4, :]
thdv3 = tmp[5, :]
P1 = tmp[6, :]
P2 = tmp[7, :]
P3 = tmp[8, :]
Pin = P1 + P2 + P3
I1rms = tmp[9, :]
I2rms = tmp[10, :]
I3rms = tmp[11, :]
V1rms = tmp[12, :]
V2rms = tmp[13, :]
V3rms = tmp[14, :]
S1 = tmp[15, :]
S2 = tmp[16, :]
S3 = tmp[17, :]
PF1 = tmp[18, :]
PF2 = tmp[19, :]
PF3 = tmp[20, :]
DPF1 = tmp[21, :]
DPF2 = tmp[22, :]
DPF3 = tmp[23, :]
Iout = tmp[24, :]
Vout = tmp[25, :]
Pout = tmp[26, :]
Pdcout = tmp[27, :]
efficiency = tmp[28, :]

A = ones([5, 2])
A[:, 1] = - Iout
B = reshape(Vout, [5, 1])
tevenen = linalg.lstsq(A, B)
Et = tevenen[0][0][0]
Rt = tevenen[0][1][0]



f = open(m_type + 'table.tex', 'w')

f.write(r'''
\begin{table}[h!]
	\caption{''' + m_type + r''' filter}
	\centering
	\bigskip
	{	
	\renewcommand{\arraystretch}{1.5}

	\begin{tabular}{l|r|r|r|r|r}
		\hline ''' + '\n')

f.write(r'$I_{OUT} \, [\text{A}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
Iout[0], Iout[1], Iout[2], Iout[3], Iout[4]) + \
r' \\ \hline' + '\n')

f.write(r'$V_{OUT} \, [\text{V}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
Vout[0], Vout[1], Vout[2], Vout[3], Vout[4]) + \
r' \\ \hline' + '\n')

f.write(r'$P_{1} \, [\text{W}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
P1[0], P1[1], P1[2], P1[3], P1[4]) + \
r' \\ \hline' + '\n')

f.write(r'$P_{2} \, [\text{W}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
P2[0], P2[1], P2[2], P2[3], P2[4]) + \
r' \\ \hline' + '\n')

f.write(r'$P_{3} \, [\text{W}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
P3[0], P3[1], P3[2], P3[3], P3[4]) + \
r' \\ \hline' + '\n')

f.write(r'$S_{1} \, [\text{VA}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
S1[0], S1[1], S1[2], S1[3], S1[4]) + \
r' \\ \hline' + '\n')

f.write(r'$S_{2} \, [\text{VA}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
S2[0], S2[1], S2[2], S2[3], S2[4]) + \
r' \\ \hline' + '\n')

f.write(r'$S_{3} \, [\text{VA}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
S3[0], S3[1], S3[2], S3[3], S3[4]) + \
r' \\ \hline' + '\n')

f.write(r'$P\!F_{1}$ & ' + \
'{:.4f} & {:.4f} & {:.4f} & {:.4f} & {:.4f}'.format( \
PF1[0], PF1[1], PF1[2], PF1[3], PF1[4]) + \
r' \\ \hline' + '\n')

f.write(r'$P\!F_{2}$ & ' + \
'{:.4f} & {:.4f} & {:.4f} & {:.4f} & {:.4f}'.format( \
PF2[0], PF2[1], PF2[2], PF2[3], PF2[4]) + \
r' \\ \hline' + '\n')

f.write(r'$P\!F_{3}$ & ' + \
'{:.4f} & {:.4f} & {:.4f} & {:.4f} & {:.4f}'.format( \
PF3[0], PF3[1], PF3[2], PF3[3], PF3[4]) + \
r' \\ \hline' + '\n')

f.write(r'$D\!P\!F_{1}$ & ' + \
'{:.4f} & {:.4f} & {:.4f} & {:.4f} & {:.4f}'.format( \
DPF1[0], DPF1[1], DPF1[2], DPF1[3], DPF1[4]) + \
r' \\ \hline' + '\n')

f.write(r'$D\!P\!F_{2}$ & ' + \
'{:.4f} & {:.4f} & {:.4f} & {:.4f} & {:.4f}'.format( \
DPF2[0], DPF2[1], DPF2[2], DPF2[3], DPF2[4]) + \
r' \\ \hline' + '\n')

f.write(r'$D\!P\!F_{3}$ & ' + \
'{:.4f} & {:.4f} & {:.4f} & {:.4f} & {:.4f}'.format( \
DPF3[0], DPF3[1], DPF3[2], DPF3[3], DPF3[4]) + \
r' \\ \hline' + '\n')

f.write(r'$P_{IN} \, [\text{W}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
Pin[0], Pin[1], Pin[2], Pin[3], Pin[4]) + \
r' \\ \hline' + '\n')

f.write(r'$P_{OUT} \, [\text{W}]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
Pin[0], Pin[1], Pin[2], Pin[3], Pin[4]) + \
r' \\ \hline' + '\n')

f.write(r'$\eta \, [\%]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
efficiency[0], efficiency[1], efficiency[2], efficiency[3], efficiency[4]) + \
r' \\ \hline' + '\n')

f.write(r'$THD(i_{1}) \, [\%]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
thdi1[0], thdi1[1], thdi1[2], thdi1[3], thdi1[4]) + \
r' \\ \hline' + '\n')

f.write(r'$THD(i_{2}) \, [\%]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
thdi2[0], thdi2[1], thdi2[2], thdi2[3], thdi2[4]) + \
r' \\ \hline' + '\n')

f.write(r'$THD(i_{3}) \, [\%]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
thdi3[0], thdi3[1], thdi3[2], thdi3[3], thdi3[4]) + \
r' \\ \hline' + '\n')

f.write(r'$THD(v_{1}) \, [\%]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
thdv1[0], thdv1[1], thdv1[2], thdv1[3], thdv1[4]) + \
r' \\ \hline' + '\n')

f.write(r'$THD(v_{2}) \, [\%]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
thdv2[0], thdv2[1], thdv2[2], thdv2[3], thdv2[4]) + \
r' \\ \hline' + '\n')

f.write(r'$THD(v_{3}) \, [\%]$ & ' + \
'{:.2f} & {:.2f} & {:.2f} & {:.2f} & {:.2f}'.format( \
thdv3[0], thdv3[1], thdv3[2], thdv3[3], thdv3[4]) + \
r' \\ \hline' + '\n')

f.write(r'''    \end{tabular}
	}
	\\
	\bigskip
	\bigskip
	$E_T = ''' + '{:.2f}'.format(Et) + r' \, \text{V}$, $R_T = ' + \
'{:.2f}'.format(Rt) + r' \, \Omega$' + \
'''

\end{table}

''')

f.close()

