#! /usr/bin/python

from pylab import *
import string
import sys

whattodo = False
par = sys.argv
if len(par) > 1:
    m_type = string.upper(par[1])
    if m_type in ['L', 'C', 'N']:
        whattodo = True
    
if whattodo == False:
    while True:
        m_type = raw_input('filter type (L, C or N): ')
        m_type = string.upper(m_type)
        if m_type in ['L', 'C', 'N']:
            break
        else:
            print 'wrong input, try again'



dp1=np.load(m_type + '/' + m_type + '1mdata.npy')
dp2=np.load(m_type + '/' + m_type + '2mdata.npy')
dp3=np.load(m_type + '/' + m_type + '3mdata.npy')
dp4=np.load(m_type + '/' + m_type + '4mdata.npy')
dp5=np.load(m_type + '/' + m_type + '5mdata.npy')

tmp = empty([29, 5])
tmp[:, 0] = dp1
tmp[:, 1] = dp2
tmp[:, 2] = dp3
tmp[:, 3] = dp4
tmp[:, 4] = dp5

thdi1 = tmp[0, :]
thdi2 = tmp[1, :]
thdi3 = tmp[2, :]
thdv1 = tmp[3, :]
thdv2 = tmp[4, :]
thdv3 = tmp[5, :]
P1 = tmp[6, :]
P2 = tmp[7, :]
P3 = tmp[8, :]
I1rms = tmp[9, :]
I2rms = tmp[10, :]
I3rms = tmp[11, :]
V1rms = tmp[12, :]
V2rms = tmp[13, :]
V3rms = tmp[14, :]
S1 = tmp[15, :]
S2 = tmp[16, :]
S3 = tmp[17, :]
PF1 = tmp[18, :]
PF2 = tmp[19, :]
PF3 = tmp[20, :]
DPF1 = tmp[21, :]
DPF2 = tmp[22, :]
DPF3 = tmp[23, :]
Iout = tmp[24, :]
Vout = tmp[25, :]
Pout = tmp[26, :]
Pdcout = tmp[27, :]
efficiency = tmp[28, :]

A = ones([5, 2])
A[:, 1] = - Iout
B = reshape(Vout, [5, 1])
tevenen = linalg.lstsq(A, B)
Et = tevenen[0][0][0]
Rt = tevenen[0][1][0]

print
print 'Et = {:.2f} V, Rt = {:.2f} ohm'.format(Et, Rt)
print


close('all')
rc('text', usetex=True)
rc('font', family='serif')
rc('font', size = 12)
rcParams['text.latex.preamble']=[r"\usepackage{amsmath}"]

#ttl = 'Filter Type ' + m_type

print 'creating figures . . . takes a while!' 

print '    1/10'
figure(0)
plot(Iout, thdi1, 'rx', label = r'$T\!H\!D(i_1)$')
plot(Iout, thdi2, 'bx', label = r'$T\!H\!D(i_2)$')
plot(Iout, thdi3, 'gx', label = r'$T\!H\!D(i_3)$')
axis([0, 6, 0, 60])
xlabel(r'$I_{OUT} \; [\text{A}]$')
ylabel(r'$[\%]$')
legend(loc = 'upper right', numpoints = 1)
savefig(m_type + '/' + m_type + '-THDi.pdf', bbox_inches = 'tight')
close('all')

print '    2/10'
figure(1)
plot(Iout, thdv1, 'rx', label = r'$T\!H\!D(v_1)$')
plot(Iout, thdv2, 'bx', label = r'$T\!H\!D(v_2)$')
plot(Iout, thdv3, 'gx', label = r'$T\!H\!D(v_3)$')
axis([0, 6, 0, 10])
xlabel(r'$I_{OUT} \; [\text{A}]$')
ylabel(r'$[\%]$')
legend(loc = 'upper left', numpoints = 1)
savefig(m_type + '/' + m_type + '-THDv.pdf', bbox_inches = 'tight')
close('all')

print '    3/10'
figure(2)
plot(Iout, I1rms, 'rx', label = r'$I_{1\,R\!M\!S}$')
plot(Iout, I2rms, 'bx', label = r'$I_{2\,R\!M\!S}$')
plot(Iout, I3rms, 'gx', label = r'$I_{3\,R\!M\!S}$')
axis([0, 6, 0, 6])
xlabel(r'$I_{OUT} \; [\text{A}]$')
ylabel(r'$[\text{A}]$')
legend(loc = 'upper left', numpoints = 1)
savefig(m_type + '/' + m_type + '-Irms.pdf', bbox_inches = 'tight')
close('all')

print '    4/10'
figure(3)
plot(Iout, V1rms, 'rx', label = r'$V_{1\,R\!M\!S}$')
plot(Iout, V2rms, 'bx', label = r'$V_{2\,R\!M\!S}$')
plot(Iout, V3rms, 'gx', label = r'$V_{3\,R\!M\!S}$')
axis([0, 6, 0, 40])
xlabel(r'$I_{OUT} \; [\text{A}]$')
ylabel(r'$[\text{V}]$')
legend(loc = 'upper right', numpoints = 1)
savefig(m_type + '/' + m_type + '-Vrms.pdf', bbox_inches = 'tight')
close('all')

print '    5/10'
figure(4)
plot(Iout, P1, 'rx', label = r'$P_1$')
plot(Iout, P2, 'bx', label = r'$P_2$')
plot(Iout, P3, 'gx', label = r'$P_3$')
plot(Iout, S1, 'r+', label = r'$S_1$')
plot(Iout, S2, 'b+', label = r'$S_2$')
plot(Iout, S3, 'g+', label = r'$S_3$')
axis([0, 6, 0, 100])
xlabel(r'$I_{OUT} \; [\text{A}]$')
ylabel(r'$[\text{W}]$')
legend(loc = 'upper left', numpoints = 1)
savefig(m_type + '/' + m_type + '-PkSk.pdf', bbox_inches = 'tight')
close('all')

print '    6/10'
figure(5)
plot(Iout, PF1, 'rx', label = r'$PF_1$')
plot(Iout, PF2, 'bx', label = r'$PF_2$')
plot(Iout, PF3, 'gx', label = r'$PF_3$')
axis([0, 6, 0, 1])
xlabel(r'$I_{OUT} \; [\text{A}]$')
legend(loc = 'lower left', numpoints = 1)
savefig(m_type + '/' + m_type + '-PF.pdf', bbox_inches = 'tight')
close('all')

print '    7/10'
figure(6)
plot(Iout, DPF1, 'rx', label = r'$DPF_1$')
plot(Iout, DPF2, 'bx', label = r'$DPF_2$')
plot(Iout, DPF3, 'gx', label = r'$DPF_3$')
axis([0, 6, 0, 1])
xlabel(r'$I_{OUT} \; [\text{A}]$')
legend(loc = 'lower left', numpoints = 1)
savefig(m_type + '/' + m_type + '-DPF.pdf', bbox_inches = 'tight')
close('all')

print '    8/10'
Pin=P1+P2+P3
figure(7)
plot(Iout, Pout, 'rx', label = r'$P_{OUT}$')
plot(Iout, Pin, 'bx', label = r'$P_{IN}$')
axis([0, 6, 0, 300])
xlabel(r'$I_{OUT} \; [\text{A}]$')
ylabel(r'$[\text{W}]$')
legend(loc = 'upper left', numpoints = 1)
savefig(m_type + '/' + m_type + '-P.pdf', bbox_inches = 'tight')
close('all')

print '    9/10'
figure(8)
plot(Iout, Vout, 'kx')
axis([0, 6, 0, 60])
xlabel(r'$I_{OUT} \; [\text{A}]$')
ylabel(r'$V_{OUT} \; [\text{V}]$')
savefig(m_type + '/' + m_type + '-Vout.pdf', bbox_inches = 'tight')
close('all')

print '    10/10'
figure(9)
plot(Iout, efficiency, 'kx')
axis([0, 6, 0, 100])
xlabel(r'$I_{OUT} \; [\text{A}]$')
ylabel(r'$\eta \; [\%]$')
savefig(m_type + '/' + m_type + '-efficiency.pdf', bbox_inches = 'tight')
close('all')

print

show()

