#! /usr/bin/python

from pylab import *
import string
import sys



def thd(x):
    n = len(x)
    X = abs(fft(x)) / n
    X1rms2 = 2 * X[1] ** 2
    Xrms2 = sum(X ** 2)
    return 100 * sqrt(Xrms2 / X1rms2 - 1)
    
def rms(x):
    return sqrt(mean(x ** 2))
    
def apower(x, y):
    return mean(x * y)

def dpf(x, y):
    X = fft(x)
    Y = fft(y)
    return cos(angle(X[1]) - angle(Y[1]))



# Let's start here!

whatfilter = False
whatcurrent = False
par = sys.argv
if len(par) > 1:
    m_type = string.upper(par[1][0])
    if m_type in ['L', 'C', 'N']:
        whatfilter = True
    if len(par[1]) > 1:
        m_out = string.upper(par[1][1])
        if m_out in ['1', '2', '3', '4', '5']:
            whatcurrent = True

if whatfilter == False:
    while True:
        m_type = raw_input('filter type (L, C or N): ')
        m_type = string.upper(m_type)
        if m_type in ['L', 'C', 'N']:
            break
        else:
            print 'wrong input, try again'

if whatcurrent == False:
    while True:
        m_out = raw_input('output current in [A] (1, 2, 3, 4, or 5): ')
        if m_out in ['1', '2', '3', '4', '5']:
            break
        else:
            print 'wrong input, try again'



t=arange(-10, 10, 0.01)

i1 = np.load(m_type + '/' + m_type + m_out + 'i1.npy')
v1 = np.load(m_type + '/' + m_type + m_out + 'v1.npy')
i2 = np.load(m_type + '/' + m_type + m_out + 'i2.npy')
v2 = np.load(m_type + '/' + m_type + m_out + 'v2.npy')
i3 = np.load(m_type + '/' + m_type + m_out + 'i3.npy')
v3 = np.load(m_type + '/' + m_type + m_out + 'v3.npy')
iout = np.load(m_type + '/' + m_type + m_out + 'iout.npy')
vout = np.load(m_type + '/' + m_type + m_out + 'vout.npy')

n = len(i1)
n2 = n / 2.

thdi1 = thd(i1)
thdv1 = thd(v1)
P1 = apower(i1, v1)
I1rms = rms(i1)
V1rms = rms(v1)
S1 = I1rms * V1rms
PF1 = P1 / S1
DPF1 = dpf(i1, v1)
I1 = abs(fft(i1)) / n2
I1[0] = I1[0] / 2
V1 = abs(fft(v1)) / n2
V1[0] = V1[0] / 2

thdi2 = thd(i2)
thdv2 = thd(v2)
P2 = apower(i2, v2)
I2rms = rms(i2)
V2rms = rms(v2)
S2 = I2rms * V2rms
PF2 = P2 / S2
DPF2 = dpf(i2, v2)
I2 = abs(fft(i2)) / n2
I2[0] = I2[0] / 2
V2 = abs(fft(v2)) / n2
V2[0] = V2[0] / 2

thdi3 = thd(i3)
thdv3 = thd(v3)
P3 = apower(i3, v3)
I3rms = rms(i3)
V3rms = rms(v3)
S3 = I3rms * V3rms
PF3 = P3 / S3
DPF3 = dpf(i3, v3)
I3 = abs(fft(i3)) / n2
I3[0] = I3[0] / 2
V3 = abs(fft(v3)) / n2
V3[0] = V3[0] / 2

Iout = mean(iout)
Vout = mean(vout)
Pout = apower(vout, iout)
Pdcout = Iout * Vout

Pin = P1 + P2 + P3

efficiency = Pout / Pin * 100

print
print
print
print 'Iout = ' + m_out + ' A'
print
print 'THD(i1) = {:.2f} %'.format(thdi1)
print 'THD(v1) = {:.2f} %'.format(thdv1)
print 'P1in = {:.2f} W'.format(P1)
print 'I1rms = {:.2f} A'.format(I1rms)
print 'V1rms = {:.2f} V'.format(V1rms)
print 'S1 = {:.2f} VA'.format(S1)
print 'PF1 = {:.4f}'.format(PF1)
print 'DPF1 = {:.4f}'.format(DPF1)
print
print 'THD(i2) = {:.2f} %'.format(thdi2)
print 'THD(v2) = {:.2f} %'.format(thdv2)
print 'P2in = {:.2f} W'.format(P2)
print 'I2rms = {:.2f} A'.format(I2rms)
print 'V2rms = {:.2f} V'.format(V2rms)
print 'S2 = {:.2f} VA'.format(S2)
print 'PF2 = {:.4f}'.format(PF2)
print 'DPF2 = {:.4f}'.format(DPF2)
print
print 'THD(i3) = {:.2f} %'.format(thdi3)
print 'THD(v3) = {:.2f} %'.format(thdv3)
print 'P3in = {:.2f} W'.format(P3)
print 'I3rms = {:.2f} A'.format(I3rms)
print 'V3rms = {:.2f} V'.format(V3rms)
print 'S3 = {:.2f} VA'.format(S3)
print 'PF3 = {:.4f}'.format(PF3)
print 'DPF3 = {:.4f}'.format(DPF3)
print
print 'Iout = {:.2f} A'.format(Iout)
print 'Vout = {:.2f} V'.format(Vout)
print 'Pout = {:.2f} W'.format(Pout)
print 'Pdcout = {:.2f} W'.format(Pdcout)
print
print 'efficiency = {:.2f} %'.format(efficiency)
print

print 'creating figures . . . takes a while!'

mdata = [thdi1, thdi2, thdi3, thdv1, thdv2, thdv3, P1, P2, P3, \
I1rms, I2rms, I3rms, V1rms, V2rms, V3rms, S1, S2, S3, PF1, PF2, PF3, \
DPF1, DPF2, DPF3, Iout, Vout, Pout, Pdcout, efficiency]

np.save(m_type + '/' + m_type + m_out + 'mdata.npy', mdata) 



rc('text', usetex=True)
rc('font', family='serif')
rc('font', size = 12)
rcParams['text.latex.preamble']=[r"\usepackage{amsmath}"]



print '    1/2'

fig=figure(num=0,figsize=(12.5,10))

ilimbase = (2, 3, 4, 6, 6)
ilim = ilimbase[int(m_out)-1]
Vlim = 40

f=fig.add_subplot(3,2,1)
f.plot(t,i1,'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_1 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f=fig.add_subplot(3,2,2)
f.plot(t,v1,'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_1 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3,2,3)
f.plot(t,i2,'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_2 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f=fig.add_subplot(3,2,4)
f.plot(t,v2,'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_2 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

f=fig.add_subplot(3,2,5)
f.plot(t,i3,'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$i_3 \; [\text{A}]$')
f.axis([-10, 10, -ilim, ilim])

f=fig.add_subplot(3,2,6)
f.plot(t,v3,'b')
f.set_xlabel(r'$t \; [\text{ms}]$')
f.set_ylabel(r'$v_3 \; [\text{V}]$')
f.axis([-10, 10, - Vlim, Vlim])

savefig(m_type + '/' + m_type + m_out + 'waveforms.pdf', bbox_inches='tight')



print '    2/2'

fig = figure(num = 1, figsize = (12.5, 10))

ind = linspace(0.6, 19.6, 20)
xt = (0, 3, 6, 9, 12, 15, 18)

f = fig.add_subplot(3, 2, 1)
f.bar(ind, I1[1 : 21], color = 'b')
f.set_xlabel(r'harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_1 \; [\text{A}]$')
f.axis([0, 20, 0, ilim])

f=fig.add_subplot(3, 2, 2)
f.bar(ind, V1[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_1 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 3)
f.bar(ind, I2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_2 \; [\text{A}]$')
f.axis([0, 20, 0, ilim])

f=fig.add_subplot(3, 2, 4)
f.bar(ind, V2[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_2 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

f=fig.add_subplot(3, 2, 5)
f.bar(ind, I3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$I_3 \; [\text{A}]$')
f.axis([0, 20, 0, ilim])

f=fig.add_subplot(3, 2, 6)
f.bar(ind, V3[1 : 21], color = 'b')
f.set_xlabel('harmonic order')
f.set_xticks(xt)
f.set_ylabel(r'$V_3 \; [\text{V}]$')
f.axis([0, 20, 0, Vlim])

savefig(m_type + '/' + m_type + m_out + 'spectra.pdf', bbox_inches='tight')

print


#show()

